Bug 131926 - Anaconda sets up grub incorrectly on dual-boot system
Anaconda sets up grub incorrectly on dual-boot system
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
2
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Peter Jones
Mike McLean
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-09-06 17:04 EDT by Andrew D. Stadler
Modified: 2008-08-02 19:40 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-10-25 16:29:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Andrew D. Stadler 2004-09-06 17:04:38 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6) Gecko/20040510

Description of problem:
I added FC2 to a laptop that already has WinXP partitions.  I asked it
to put the bootloader in the /boot partition (not on the disk's MBR).
 I also used the technique listed in Ed's How-To
<http://www.geocities.com/epark/linux/grub-w2k-HOWTO.html> to copy the
stage1 block into my C: drive.

(my goal was to do this w/o altering the hd's MBR, and anaconda seems
to support this idea when it lets you write the bootloader into a
partition)

The problem:  Anaconda misunderstood my partition map and configured
stage2 and the grub.conf files incorrectly (they point at the wrong
partition).

Here is my partition map (as seen by grub)

hd0,    contains
0       NTFS c: partition
1       ext2 /boot partition (where all GRUB stuff is)
2       extended
3       FAT32 IBM hidden restore (where anaconda thinks grub is)
4       NTFS d: partition
5       ext3 / partition
6       swap
7       FAT32 shared partition

Booting into grub (via windows bootloader) brought up the grub CLI,
but not the menu.  It required two fixes to make it actually work.

(1)  I had to edit the (boot)/grub/grub.conf and changes all
references from (hd0,3) <incorrect> to (hd0,1) <correct>.  Now, if I
type configfile (hd0,1)/grub/grub.conf it jumps into the menu.

(2)  I had to use "setup (hd0,1)" to instruct grub to rewrite the
part2 file with the correct (hd0,1) location of the config file.

Now, it works perfectly.

I think the core problem here is that, for some reason, anaconda and
grub are viewing my partition map differently, and anaconda is writing
out the grub files based on its (different?  incorrect?) understanding
of the layout.


Version-Release number of selected component (if applicable):


How reproducible:
Didn't try

Steps to Reproduce:
see problem description.

Additional info:
Comment 1 Jeremy Katz 2004-09-07 14:17:13 EDT
Why did anaconda think that /boot was to be /dev/hda4?  Did you modify
your partitioning at some point?
Comment 2 Andrew D. Stadler 2004-09-09 03:07:30 EDT
Yes, in fact, I did a bit of partitioning as part of the anaconda
process.  Here are the partition maps (as I remember them)

Before installing - this was a tweaked XP setup, I had made room using
Partition Magic.

NTFS C: in 1st primary partition
NTFS D: in extended partition (in 3rd pri. slot)
IBM restore partition, the 4th primary slot

There was empty space in the 2nd primary slot and within the extended
partition

Then while in the anaconda system, I added linux partitions:

/boot in 2nd primary
/ in the extended
swap in the extended
FAT32 in the extended*

Then I proceeded thru the rest of the installer.  As mentioned above,
I instructed anaconda to put the boot stuff in the /boot partition,
not in the MBR.

*One note:  I can't remember, I *might* have added the FAT32 partition
after the installation, but I don't think so.  In any case, would that
matter?  It's a high number, so I wouldn't expect it to have affected
anaconda/grub since the confusion lies in much lower numbered partitions.

What else would help?

Comment 3 Jeremy Katz 2005-04-14 17:07:04 EDT
Does this still happen with fc4 test?
Comment 4 John Thacker 2006-10-25 16:29:25 EDT
Closing per previous comment and lack of response.  Also note that FC1 and FC2
are no longer supported even by Fedora Legacy.

Note You need to log in before you can comment on or make changes to this bug.